package edu.utk.cs.icl.perfometer.datatransfer;

public interface DataReader {
  public static final boolean DEBUG_CONNECTION  = false;

  public static final String PERF_SERVER        = "0";
  public static final String PERF_APP           = "1";
  public static final String PERF_ACK           = "2";
  public static final String PERF_NEEDAPP       = "3";
  public static final String PERF_NONEEDAPP     = "4";
  public static final String PERF_END           = "5";
  public static final String PERF_FAILEDCONN    = "6";
  public static final String PERF_STARTAPP      = "7";
  public static final String PERF_ANY           = "8";
  public static final String PERF_PAUSE         = "9";
  public static final String PERF_ABORT         = "10";
  public static final String PERF_OK            = "11";
  public static final String PERF_ERROR         = "12";
  public static final String PERF_DATA          = "13";
  public static final String PERF_POLL          = "14";
  public static final String PERF_HWINFO        = "15";
  public static final String PERF_EXEINFO       = "16";
  public static final String PERF_EVENTLIST     = "17";
  public static final String PERF_CHANGE_EVENT  = "18";
  public static final String PERF_DATASTREAM    = "19";
  public static final String PERF_POPUP         = "20";
  public static final String PERF_BREACH        = "21";
  public static final String PERF_MPI           = "22";
  public static final String PERF_DIED          = "23";
  public static final String PERF_ADDAPP        = "24";
  public static final String PERF_MHZ           = "25";

  public static final int PERF_SERVER_int        = 0;
  public static final int PERF_APP_int           = 1;
  public static final int PERF_ACK_int           = 2;
  public static final int PERF_NEEDAPP_int       = 3;
  public static final int PERF_NONEEDAPP_int     = 4;
  public static final int PERF_END_int           = 5;
  public static final int PERF_FAILEDCONN_int    = 6;
  public static final int PERF_STARTAPP_int      = 7;
  public static final int PERF_ANY_int           = 8;
  public static final int PERF_PAUSE_int         = 9;
  public static final int PERF_ABORT_int         = 10;
  public static final int PERF_OK_int            = 11;
  public static final int PERF_ERROR_int         = 12;
  public static final int PERF_DATA_int          = 13;
  public static final int PERF_POLL_int          = 14;
  public static final int PERF_HWINFO_int        = 15;
  public static final int PERF_EXEINFO_int       = 16;
  public static final int PERF_EVENTLIST_int     = 17;
  public static final int PERF_CHANGE_EVENT_int  = 18;
  public static final int PERF_DATASTREAM_int    = 19;
  public static final int PERF_POPUP_int         = 20;
  public static final int PERF_BREACH_int        = 21;
  public static final int PERF_MPI_int           = 22;
  public static final int PERF_DIED_int          = 23;
  public static final int PERF_ADDAPP_int        = 24;
  public static final int PERF_MHZ_int           = 25;
  
  public static final String STR_DEL = "^";
  public static final String RANK_DEL = "@";

  public void establishConnection(String host, int port) 
     throws java.io.IOException;
  public void disconnect() throws java.io.IOException;
  public void sendStart(int idx) throws java.io.IOException;
  public void sendPause(int idx) throws java.io.IOException;
  public void sendDatastreamStop(int idx) throws java.io.IOException;
  public void sendDatastreamStart(int idx) throws java.io.IOException;
  public void sendPopupParameters(int idx, double min, double max,
     int thresh, int data) throws java.io.IOException;
  public void sendPollingInterval(int idx, int pollIntMs);
  public DataItem getItem(DataItem d);
  public boolean isServer();
}
