package edu.utk.cs.icl.perfometer.datatransfer;

import edu.utk.cs.icl.perfometer.metrics.MetricParser;

import java.util.Enumeration;

public interface ProcessManager {
  static final int DEFAULT_TABLE_SIZE = 23;

  public void add(int rank, PerfProcessInfo pinfo, MetricParser m);
  public void remove(int rank);
  public Object get(int rank);
  public PerfProcessInfo getProcInfo(int rank);
  public void setDataReader(DataReader d);
  public void setMetricParser(int rank, MetricParser m);
  public void changeAllMetrics(MetricParser m);
  public MetricParser getMetricParser(int rank);
  public Enumeration elements();
}
