package edu.utk.cs.icl.perfometer.event;

public class PerfBreachEvent extends java.util.EventObject {
  private double min, max, actual;
  private int rank;

  public PerfBreachEvent(Object source, int r, double minVal,
     double maxVal, double actualVal)
  {
    super(source);
    rank = r;
    min = minVal;
    max = maxVal;
    actual = actualVal;
  }

  public double getMin() {
    return min;
  }

  public double getMax() {
    return max;
  }

  public double getActual() {
    return actual;
  }

  public int getRank() {
    return rank;
  }
}
