package edu.utk.cs.icl.perfometer.datatransfer;

public class PerfProcessInfo {

  private int rank;
  private PerfHwInfo hwInfo;
  private PerfProgramInfo exeInfo;
  private PerfMetric[] eventList;

  public PerfProcessInfo(int r, PerfHwInfo h, PerfProgramInfo p, PerfMetric[] m)
  {
    rank = r; 
    hwInfo = h;
    exeInfo = p;
    eventList = m;
  }

  public int getRank() {
    return rank;
  }

  public PerfHwInfo getHwInfo() {
    return hwInfo;
  }

  public PerfProgramInfo getExeInfo() {
    return exeInfo;
  }

  public PerfMetric[] getEventList() {
    return eventList;
  }

}
