package edu.utk.cs.icl.perfometer.gui_common;

import java.applet.*;
import java.net.*;
import java.io.*;

public class AudioClipPlayer extends Thread {
  AudioClip clip = null;

  private static AudioClipPlayer instance = null;

  protected AudioClipPlayer() {
  }

  public static AudioClipPlayer getInstance() {
    if(instance == null) {
      instance = new AudioClipPlayer();
      instance.start();
    }

    return instance;
  }

  public void run() {
    // do nothing here

    for(;;)
      try {Thread.sleep(15000); } catch (InterruptedException e){}
  }

  public void startClip()
  {
    if(clip != null)
      clip.play();
  }

  public void stopClip()
  {
    if(clip != null)
      clip.stop();
  }

  public void setClipURL(String arg)
  {
    try {

      clip = Applet.newAudioClip (new URL(arg));

    } catch (MalformedURLException e) {
       // do whatever
    } catch (IOException e2) {
       // do whatever
    }
  }
}
