package edu.utk.cs.icl.perfometer.micro_gui;

import java.awt.Dialog;
import java.awt.Button;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Frame;
import java.awt.FlowLayout;
import java.awt.BorderLayout;

public class ErrorMessage extends Dialog 
  implements java.awt.event.ActionListener
{

  Label label;
  Button okButton;

  public ErrorMessage(Frame owner, String title, String text) {
    super (owner, title, true);

    this.setSize(text.length() * 8, 100);

    label = new Label(text);
    okButton = new Button("OK");
    okButton.addActionListener(this);

    this.setLayout(new BorderLayout(5,5));

    Panel lowerPanel = new Panel();
    lowerPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
    lowerPanel.add(okButton);

    this.add("North",label);
    this.add("South",lowerPanel);
  }

  public void actionPerformed(java.awt.event.ActionEvent e) {
    if(e.getSource() == okButton)
      this.dispose();
  }
}
